{ Include file for GWInfo - Card detection. Portions by Edwin Raspe }

FUNCTION Dec2Hex(d:LONGINT; width:BYTE):STRING;
{
  Converts a decimal based number to a hexadecimal based number with
  width 'width', the number being defined by 'd'.
}
VAR result:STRING;
    i,j:BYTE;
BEGIN
  result:='00000000';
  j:=8;
  WHILE (d<>0) DO
  BEGIN
    i:=(d AND $0000000F);
    d:=d SHR 4;
    result[j]:=HexDigits[i+1];
    Dec(j);
  END;
  result:=Copy(result,8-width+1,width);
  Dec2Hex:=result;
END;

function hex2dec(hex:string):integer;  {input 2 dig hex number}
var e,result,result2:integer;
begin
  for e:=1 to 16 do
    if hexdigits[e]=hex[1] then result:=e-1;
  for e:=1 to 16 do
    if hexdigits[e]=hex[2] then result2:=e-1;
  hex2dec:=result*16+result2;
end;


{*********************************************** pnp and pci ************* }

procedure detectpci;
var temp2,temp3,devtemp,addlinetemp:string;
 fileinfo:searchrec;

begin
    maxpci:=0;
    line:=paramstr(0);
    while (line[length(line)]<>'\') and (length(line)>1) do delete(line,length(line),1);
      delete(line,length(line),1);
    line:=line+'\';
    fileout:='C:\PCI.TXT';
    assign(outfile,fileout);   {test if c: ok to write to}
    rewrite(outfile);
    if ioresult<>0 then stop(2);
    close(outfile);
    swapvectors;
    exec(getenv('COMSPEC'),'/C '+line+'GWPCICFG.EXE -t * > '+fileout);
    swapvectors;
    findfirst(fileout,anyfile,fileinfo);
    if doserror=0 then begin
      temp:='';
      addlinetemp:='';
      openfi(fileout);
      while not eof(infile) do begin
        readln(infile,line);
        if ioresult<>0 then exit;
{        if line[1]='P' then :=dev+1;                 {next pci dev}
        if line[2]='V' then temp:=copy(line,9,4);       {ven}
        if line[2]='D' then devtemp:=temp+copy(line,11,4); {dev}
        if line[42]='C' then temp2:=copy(line,48,2);    {class}
        if line[42]='S' then begin       {subclass}
          temp2:=temp2+copy(line,48,2);
          line:=copy(temp2,1,2);
          line:=class[hex2dec(line)];
          for i:=1 to 45 do
            if ClassSubCode[i]=temp2 then line:=line+' - '+ClassSubDesc[i];
          {if copy(temp2,3,2)='80' then line:=line+' - other';}

          found:=false;
          temp3:=copy(temp2,2,1);
          if (temp3<>'1') and (temp3<>'2') and (temp3<>'3')
          and (temp3<>'4') and (temp3<>'7') then begin
            addlinetemp:=' '+line;
            found:=true;
          end;
          {else begin}
           for i:=1 to cardsmax do begin
            if devtemp=cardsid[i] then begin
             if length(addlinetemp)>0 then addlinetemp:=addlinetemp+' - '+cards[i]
             else addlinetemp:=' '+cards[i];
             found:=true;
            end;
           end;
{          end;}
          if not found then begin
          for i:=cardsmax downto 1 do begin
            if copy(devtemp,1,4)=cardsid[i] then begin
              addlinetemp:=' '+cards[i]+' - unknown device - '+line+': '+devtemp;
              found:=true;
            end;
           end;
          end;
        if not found then addlinetemp:=' Unknown '+line+': '+devtemp;
{        addlinetemp:=addlinetemp+', rev '+Dec2Hex(pcidata.rev,2);}
{        if rom<>'' then temp:=temp+', ROM: '+rom;
        if not ((pos('wn: ',temp)>0) and (rom='32K')) then begin}
          maxpci:=maxpci+1;
          pci[maxpci,1]:=addlinetemp;
          pci[maxpci,2]:=temp2;
          addlinetemp:='';
{        end;}

  {        device[dev,2]:=line;}
        end;
      end;
      close(infile);
      erase(infile);
    end;
end;

PROCEDURE ResetPnPCards(value:BYTE);
{
 value b0=1: Reset cards to default state. Don't affect CSN.
 value b1=1: Put PnP cards into wait for key state. Don't affect CSN.
 value b2=1: Reset CSN to 0.
}
BEGIN
  Port[cap]:=$02; {Configuration Control register}
  Delay(1);
  value:=(value AND 7);
  Port[wdp]:=value;
  Delay(10);
END;

PROCEDURE SendPnPInitiationKey;
{
  Sends the 32 byte initiation key, to put the cards into the
  isolation state.
}
VAR lfsr,i,eor:BYTE;
BEGIN
  Port[cap]:=$00; {Two times $00 to CAP resets LFSR to $6A}
  Delay(1);
  Port[cap]:=$00;
  Delay(1);

  lfsr:=$6A;

  FOR i:=1 TO 32 DO
  BEGIN
    Port[cap]:=lfsr;           {lfsr to CAP}
    Delay(1);
    eor:=(lfsr AND 3);         {XOR b0 and b1}
    lfsr:=(lfsr SHR 1);
    IF ((eor=1) OR (eor=2))    {XOR 1?}
    THEN lfsr:=(lfsr OR 128);  {Then b7 of lfsr becomes 1}
  END;
END;

PROCEDURE SendPnPCSN(csn:BYTE);
{
  Sends the csn defined by 'csn' to the wake command register.
}
BEGIN
  Port[cap]:=$03; {Wake Command register}
  Delay(1);
  Port[wdp]:=csn;
  Delay(1);
END;

PROCEDURE SetPnPCSN(csn:BYTE);
{
  Sets the csn defined by 'csn' to the PnP card in configuration state.
}
BEGIN
  Port[cap]:=$06; {CSN register}
  Delay(1);
  Port[wdp]:=csn;
  Delay(1);
END;

FUNCTION ReadPnPByte:BYTE;
{
  Reads (and returns) a byte from the PnP cards Resource Data register
}
BEGIN
  Port[cap]:=$05; {Status register}
  Delay(1);
  WHILE ((Port[rdp] AND 1)=0) DO Delay(1);
  Port[cap]:=$04; {Resource Data register}
  Delay(1);
  ReadPnPByte:=Port[rdp];
  Delay(1);
END;


PROCEDURE ReadPnPSerialID(VAR checksumOK:BOOLEAN);
{
  Reads the 72 bit PnP Serial ID from the card if present. This ID
  is stored in the global variable 'serialID'.
  'result' is only TRUE when a valid checksum is encountered.
}
VAR lfsr:BYTE;
    i,j:BYTE;
    value,mask:BYTE;
    eor1,eor2:BYTE;
    b1,b2:BYTE;

BEGIN
  Port[cap]:=$01; {Serial Isolation register}
  Delay(1);

  lfsr:=$6A;      {LFSR to initial value of 6A}

  FOR i:=1 TO 9 DO BEGIN
    mask:=1;
    value:=0;
    FOR j:=1 TO 8 DO BEGIN
      b1:=Port[rdp]; {read 2 bytes from rdp}
      Delay(1);
      b2:=Port[rdp];
      Delay(1);

      eor1:=(lfsr AND 3);  {first XOR of checksum logic}

      IF ((eor1=1) OR (eor1=2)) THEN eor1:=1
      ELSE eor1:=0;

      IF ((b1=$55) AND (b2=$AA)) THEN BEGIN
        value:=value+mask; {adjust current serial ID byte}
        eor2:=1;
      END
      ELSE BEGIN
        eor2:=0;
      END;
      mask:=mask SHL 1;  {adjust mask}

      IF (i<>9) THEN BEGIN
        lfsr:=(lfsr SHR 1);  {second XOR of checksum logic}
        IF ((eor1 XOR eor2)=1) THEN lfsr:=lfsr + $80;
      END;

    END;
    serialID[i]:=value;
  END;
  checksumOK:=((serialID[9]=lfsr) AND (serialID[9]<>0));
END;

PROCEDURE SetPnPReadPort;
BEGIN
  Port[cap]:=$00; {Set RDP Address register}
  Delay(1);
  Port[wdp]:=rdpb92;
  Delay(1);

  rdp:=rdpb92;
  rdp:=((rdp SHL 2)+3);
END;


PROCEDURE SelectPnPReadPort(VAR result:BOOLEAN);
{
  Selects a valid read port address between 203h and 3FFh. Returns
  'TRUE' when successfull. A 'FALSE' here must be interpreted as no PnP
  devices installed on (E)ISA bus.
}
VAR
    i,j:BYTE;
    ready,checksumOK:BOOLEAN;
BEGIN

  rdpb92:=$80;
  ready:=FALSE;
  WHILE (NOT ready) DO BEGIN
    ResetPnPCards(7);
    SendPnPInitiationKey;
    SendPnPCSN(0);
    SetPnPReadPort;
    ReadPnPSerialID(checksumOK);
    IF (checksumOK) THEN BEGIN
      SetPnPCSN(1);
      ResetPnPCards(2);
      SendPnPInitiationKey;
      SendPnPCSN(1);

      j:=1;
      checksumOK:=TRUE;
      WHILE ((j<10) AND (checksumOK)) DO BEGIN
        resourceID[j]:=ReadPnPByte;
        checksumOK:=(resourceID[j]=serialID[j]);
        Inc(j);
      END;

      ResetPnPCards(6);
      ready:=checksumOK;
      result:=TRUE;
    END
    ELSE BEGIN
      rdpb92:=rdpb92+$08;
      IF (rdpb92=0) THEN BEGIN
        ready:=TRUE;
        result:=FALSE;
      END;
    END;
  END;
END;

PROCEDURE AssignPNPCSN;
{
  Assigns a Card Select Nuber (CSN) to every PnP card in the system.
}
VAR i:BYTE;
    pnpinstalled:BOOLEAN;
BEGIN
  ResetPnPCards(7);
  SendPnPInitiationKey;
  SetPnPReadPort;
  i:=1;
  pnpinstalled:=TRUE;
  WHILE (pnpinstalled) DO BEGIN
    SendPnPCSN(0);
    ReadPnPSerialID(pnpinstalled);
    SetPnPCSN(i);
    IF (pnpinstalled) THEN Inc(i);
  END;
  numberofpnpcards:=i-1;
END;

PROCEDURE IdentifyPnPCards;
             { Ids every ID string in each PnP card installed.}
VAR i,ii,j,descriptor,noblo,nobhi,countrylo,countryhi,version1,version2:BYTE;
    w:WORD;
    ready:BOOLEAN;
    idfile:TEXT;
    pnpdata:ARRAY[1..10] OF STRING;
    noids:BYTE;
    logicalID:STRING;
    version,dummy:BYTE;
 {   totalbytes:LONGINT;         don't need this stuff
    checksum:WORD;      }
    temp:string;

BEGIN
  temp:='';
  FOR i:=1 TO numberofpnpcards DO BEGIN
{    totalbytes:=0;}
    ResetPnPCards(2);
    SendPnPInitiationKey;
    SendPnPCSN(i);
    noids:=0;
    logicalID:='';
{    checksum:=0;}
    FOR j:=1 TO 9 DO dummy:=ReadPnPByte;
    ready:=FALSE;
    WHILE (NOT ready) DO BEGIN
      descriptor:=ReadPnPBYTE;
{      checksum:=checksum+descriptor;
      Inc(totalbytes);}
      IF ((descriptor AND 128)=128) THEN BEGIN {large descriptor}
        noblo:=ReadPnPByte;
        nobhi:=ReadPnPByte;
{        checksum:=checksum+noblo+nobhi;
        totalbytes:=totalbytes+2;}
        IF ( ((descriptor AND 2)=2) OR ((descriptor AND 3)=3)) THEN
        BEGIN
          Inc(noids);
          {ANSI or unicode ID string}
          IF ((descriptor AND 3)=3) THEN BEGIN
            {UNICODE}
            countrylo:=ReadPnPByte;
            countryhi:=ReadPnPByte;
{            totalbytes:=totalbytes+2;         don't need this info here
            checksum:=checksum+countrylo+countryhi;
            WriteLn('UniCode Country ID: ',Dec2Hex(countrylo+256*countryhi,4));}
          END;
          pnpdata[noids]:='';
          FOR w:=1 TO (noblo+256*nobhi) DO BEGIN
            dummy:=ReadPnPByte;
            pnpdata[noids]:=pnpdata[noids]+Chr(dummy);
 {           checksum:=checksum+dummy;
            Inc(totalbytes);}
          END;
        END
        ELSE BEGIN
          {Something Else}
          FOR w:=1 TO (noblo+256*nobhi) DO BEGIN
            dummy:=ReadPnPByte;
 {           checksum:=checksum+dummy;
            Inc(totalbytes);}
          END;
        END;
      END
      ELSE BEGIN {small descriptor}
        IF ((descriptor AND 120)=16) THEN BEGIN
          noblo:=(descriptor AND 7);
          FOR w:=1 TO noblo DO BEGIN
            dummy:=ReadPnPByte;
            logicalID:=logicalID+Dec2Hex(dummy,2);
{            checksum:=checksum+dummy;
            Inc(totalbytes);}
          END;
        END
        ELSE BEGIN
          IF ((descriptor AND 120)=8) THEN BEGIN
            version:=ReadPnPByte;
            inc(noids);
{            WriteLn('Minor version : ', ;
            WriteLn('Major version : ', ;}
            str(((version SHR 4) AND 15),line);
            str((version AND 15),temp);
            pnpdata[noids]:=line+'.'+temp;
{            checksum:=checksum+version;}
            version:=ReadPnPByte;
{            WriteLn('Vendor version: ',}
            inc(noids);
            str(version,pnpdata[noids]);
 {           checksum:=checksum+version;
            totalbytes:=totalbytes+2;}
          END
          ELSE BEGIN
            noblo:=(descriptor AND 7);
            FOR w:=1 TO noblo DO BEGIN
              dummy:=ReadPnPByte;
{              checksum:=checksum+dummy;
              Inc(totalbytes);}
            END;
          END;
        END;

        ready:=((descriptor AND 120)=120);
      END;
    END;
    temp:=' '+pnpdata[3];
{    IF (logicalID<>'') THEN BEGIN
        found:=false;
        for ii:=1 to cardsmax do begin
         if logicalID=cardspnp[1,ii] then begin
          temp:=temp+cards[2,ii+250]+') ';
          found:=true;
         end;
        end;
        if not found then temp:=temp+'DeviceID: '+LogicalID+') ';
    END;}
    temp:=temp+'version '+pnpdata[2]+', revision '+pnpdata[1];
    addline(temp);
    temp:='  Inbuilt devices:  ';
    FOR w:=4 TO noids DO temp:=temp+pnpdata[w]+', ';
    delete(temp,length(temp)-1,2);
    addline(temp);
{    WriteLn('Total number of bytes read: ',totalbytes);
    WriteLn('Checksum: ',checksum);}
  END;
  if temp='' then addline(' none');
END;

